var N = 16,
J = 1,
T = 1,
step = 0,
timestep = 500,
canvas = document.getElementById("myCanvas"),
context = canvas.getContext("2d"),
animateButton = document.getElementById("animateButton"),
paused = true,
count = 0
startTime = 0,
temp = document.getElementById("temp");

var lattice = new Array();

function getLattice(){
    for (let i=0;i<N;i++){
        lattice[i]=new Array();
        for (let j=0;j<N;j++){
            lattice[i][j] = 2*Math.round(Math.random()) - 1;
        } 
    }
}


function flip(lt) {
    for (let j=0;j<N**2;j++){
        let a=Math.floor(Math.random()*N);
        let b=Math.floor(Math.random()*N);
        var s=lt[a][b];
        var E=lt[(a+1)%N][b] + lt[a][(b+1)%N] + lt[(a-1+N)%N][b] + lt[a][(b-1+N)%N];
        var P=Math.exp((-2)*J*s*E/T)
        if (Math.random()<P) {
            lt[a][b] *= -1;
        }     
    }
    return lt
}

function countM(lt){
    let M = 0;
    for (let i=0;i<N;i++){
        for (let j=0;j<N;j++){
            M += lt[i][j];
        }
    }
    return M;
}

function writeLattice(lt){
    document.write("<br />")
    for (i=0;i<lt.length;i++){
        document.write(lt[i] + "<br />");
    }
}

function draw(lt){
    context.clearRect(0,0,256,256);
    var c;
    for (let i = 0;i < N;i ++){
        for (let j = 0;j < N;j ++){
            c = 255 * (lt[i][j] + 1) / 2
            context.fillStyle = 'rgb(' + c + ',' + c + ',' + c + ')';
            context.fillRect (i*16,j*16,16,16);
        }
    }
}


function animation(time){
    if (!paused){
        if (startTime == 0){
            startTime = time
        }
        if (Math.floor(time - startTime) / timestep > count){
            flip(lattice);
            draw(lattice);
            step ++ ;
            count ++ ;
        }
        document.getElementById("s").innerHTML = '步数 = ' + step;    
    }
    document.getElementById("T").innerHTML = '温度T = ' + T + ',' + '总磁矩M = ' + countM(lattice);
    requestAnimationFrame(animation);  
}

getLattice();
flip(lattice);
draw(lattice);
animation();

animateButton.onclick = function() {
    if (paused) {
        paused = false;
        animateButton.value = "暂停";
        startTime = 0;
        count = 0;
    }
    else {
        paused = true;
        animateButton.value = "开始";
    }
}

temp.onchange = function(e){
    T = temp.value / 2;
    startTime = 0;
}