# -*- coding: utf-8 -*-
"""
Created on Fri Jun  5 03:12:38 2020

@author: 17307110060
"""
import numpy as np
from numpy.random import rand
import math
import matplotlib.pyplot as plt

def inital_state(N):
  state=2*np.random.randint(2,size=(N,N))-1 # 产生一个N个粒子的二维ising模型，元素只能取1或者-1
  return state

def ther(J,grid,T): # J为耦合常数，T为温度，chain为系统的初始状态。
  for i in range(N * N):
          a=np.random.randint(0,N)
          b=np.random.randint(0,N)#任取链上的一个格点a
          s=grid[a][b]#取格点a的自旋
          E=grid[(a+1)%N][b]+grid[a][(b+1)%N]+grid[(a-1)%N][b]+grid[a][(b-1)%N]#该格点与其相邻格点的作用能
          Energy_old=(-1)*J*s*E#反转前的能量
          Energy_new=s*E*J#将格点的自旋翻转，得到新的能量
          P=np.exp(-(Energy_new-Energy_old)/T)
          if P>1:#反转后的能量小于原来的能量，接受这个翻转
            s*=-1
          elif rand()<P:#否则按指数概率接受这个翻转
            s*=-1
          grid[a][b]=s
  return grid
#热化函数，用于达到热平衡

def calculate_energy(J,grid):#计算能量
    energy = 0
    N = len(grid)
    for i in range(N):
        for j in range(N):
            S = grid[i][j]
            E = grid[(i+1)%N][j] + grid[i][(j+1)%N] + grid[(i-1)%N][j] + grid[i][(j-1)%N]
            energy += -J*E*S  # 引入%，是为了实现周期性边界条件
    return energy/2 # 每对格点被计算了两次，需要除以2


N=2**4#正方晶格边长
J=1#耦合常数
eqSteps=2**8#热化的步骤
mcSteps=2**9#热化完成后的抽样数目
Energy=[]#储存不同温度下的能量
Eerror=[]
R=list(range(0,32))
SpecificHeat=[]#储存不同温度下的热容
Serror=[]
nt=2**6#所取温度数目
T=np.linspace(2,3,nt)#温度区间
T=list(T)

#求不同温度下的能量与热容
for t in T :
    # 初始构型
    E = 0 #记录能量
    S = 0 #记录能量的平方
    SS = 0
    config = inital_state(N)
    # 热化，达到平衡态
    for i in range(eqSteps):
        ther(J,config,t)
    # 抽样计算
    for i in range(mcSteps):
        ther(J,config,t)
        e = calculate_energy(J,config)
        S += e*e
        E += e
    Energy.append(E/mcSteps)
    Eerror.append(math.sqrt((S/mcSteps-(E/mcSteps)**2)/mcSteps))
    SpecificHeat.append(((S/mcSteps-(E/mcSteps)**2)/(t*t)))#Cv=(<E^2>-<E>^2)/T^2    
#绘图
f = plt.figure(figsize=(18, 10)); # plot the calculated values    
 
sp =  f.add_subplot(2, 2, 1 );
plt.errorbar(T,Energy,yerr=Eerror,fmt='o',ecolor='r',color='b',ms=3,elinewidth=2,capsize=4);
plt.xlabel("Temperature (T)", fontsize=20);
plt.ylabel("Energy ", fontsize=20);

sp =  f.add_subplot(2, 2, 2 );
plt.plot(T, SpecificHeat, 'ro',T,SpecificHeatC);
plt.xlabel("Temperature (T)", fontsize=20);
plt.ylabel("Specific Heat ", fontsize=20);